#include "carte.hpp"

K8055::K8055 (connexion &c)
{
//check the presence of the card  
  uh=-1;
  if (PRESENTE)
    init(c);
}

void K8055::init(connexion & c)
{
  int device=0;
  usb_init();
  uh = OpenDevice(device);
  if(uh < 0)
    {
      printf("Error connecting to device\n");
      // error type 1 in table error
      insert_error(c,1);c.set_stop();c.close();exit(EXIT_FAILURE);
    }
  }

K8055::~K8055()
{
  if (PRESENTE)
    arret();
}

void K8055::arret()
{
  CloseDevice();
}


//change output state - write log
void K8055::change_state(connexion &c, short out,short state,string s)
{
string st,st2,s2;
time_t rawtime;

time ( &rawtime );
s2=ctime(&rawtime);
string h=s2.substr(s2.find(":",0)-2,5);
st=st+ h + s ;
if (state==0) st2=": off\n"; else st2=": on\n";
st =st +st2;
//cout << st << endl;

if (PRESENTE)
{
	if (state==1) SetDigitalChannel(out);
	else ClearDigitalChannel(out);
}
c.insert_log(s+st2);
c.maj_out(out,state);
}


//print status
void K8055::print_status(long uh,config &cfg)
{
double temperature;

cout << "**** status ****\n";
cout << "=>inputs:\n";
cout << "configuration\n";
cout << "flowmeter " << cfg.FLOW << endl;
if (read(cfg.STOP_PUMP)==1) cout  << setw(17) << "button 1:stopping pump for 10 min\n";
if (read(cfg.STOP_SKIMMER)==1) cout << setw(17) << "stopping skimmer\n";
if (read(cfg.OSMOLATION)==1) cout << setw(17) << "osmolation activated by captor\n";
if (read(cfg.RESERV)==1) cout << setw(17) << "RESERV EMPTY !!!\n";
temperature =(double) (101*readAnalog(INP_TEMP)/256)-23;
cout << "temperature : " << temperature << endl;	

cout << "\n=>outputs:\n";
cout << "out  "<< cfg.OUTHQI<< endl; 
if (read(cfg.OUTHQI)!=0) cout << setw(17) << "HQI working\n"; else cout <<"HQI stopped\n";
cout << "out  "<< cfg.OUTBLUE<< endl;
if (read(cfg.OUTBLUE)!=0) cout << setw(17) <<"Blue light working\n"; else cout <<"Blue light stopped\n";
cout << "out  "<< cfg.OUTPUMP<< endl;
if (read(cfg.OUTPUMP)!=0) cout << setw(17) <<"Pump working\n"; else cout <<"Pump stopped\n";
cout << "out  "<< cfg.OUTSKIMMER<< endl;
if (read(cfg.OUTSKIMMER)!=0) cout << setw(17) << "Skimmer working\n"; else cout <<"Skimmer stopped\n";
cout << "out  "<< cfg.OUTOSMOLATION<< endl;
if (read(cfg.OUTOSMOLATION)!=0) cout << setw(17) << "osmolation working\n"; else cout <<"Osmolation stopped\n";
cout << "out  "<< cfg.OUTRAH<< endl;
if (read(cfg.OUTRAH)!=0) cout << setw(17) << "RAH pump working\n"; else cout <<"RAH pump stopped\n";
cout << "out  "<< cfg.OUTTEMP<< endl;
if (read(cfg.OUTTEMP)!=0) cout << setw(17) << "Chauffage working\n"; else cout <<"Chauffage stopped\n";
cout << "out  "<< cfg.OUTPERI<< endl;
if (read(cfg.OUTPERI)!=0) cout << setw(17) << "Peristatic pump working\n"; else cout <<"Peristatic pump stopped\n";

}

int K8055::read(int bit)
{
//check the presence of the card  
	if (PRESENTE)
		return ReadDigitalChannel(bit);
	else return 0;
}

double K8055::readAnalog (int bit)
{
	if (PRESENTE)
		return (double)ReadAnalogChannel(bit);
	else return 0;
}

double K8055::readcounter(int bit)
{
	if (PRESENTE)
		return (double)ReadCounter(bit);
	else return 0;
}


void K8055::resetcounter(int bit)
{
	if (PRESENTE)
		ResetCounter(bit);
}
