#include "peristatic.hpp"

void Peristatic::init()
{
  state=0;
  state_sauv=0;
}

void Peristatic::forceState(short forcedState,connexion &c,K8055 &k,config &cfg)
{
  if (forcedState!=state)
    {
      state_sauv=state;
      state=forcedState;
      k.change_state(c, cfg.OUTPERI,state,"pompe doseuse forced");
    }
}

void Peristatic::changeState (short state,connexion &c,K8055 &k,config &cfg)
{
  this->state=state;
  state_sauv=state;
  k.change_state(c, cfg.OUTPERI,state,"pompe doseuse");
}


short Peristatic::get_State(string s,connexion  &c)
{
  temps t,tbegin,tend;
  bool button,b;
  bool r[5];
  short i;
  param p;
  
  t.set_current_time();
//for all hour plages
  for(i=0;i<5;i++)
    {
      c.get_parameter("pdoseuse",p,i+1);
      tbegin.set_time(p.get_init_timer());
      tend.set_time(p.get_end_timer());
      button=p.get_button();
      b=t.inclus(tbegin,tend);
      if(b==true && button==true) r[i]=true;
      if(b==true && button==false) r[i]=false;
      if(b==false) r[i]=false;
    }
  
  if (r[0]||r[1]||r[2]||r[3]||r[4]) return 1; else return 0;
}


void Peristatic::changing(short st,connexion& c,K8055&k,config&cfg)
{
  if(cfg.forced_peri!=0) 
    forceState(cfg.forced_peri-1,c,k,cfg);
  else
    {
      if (state!=state_sauv)
    	changeState(state_sauv,c,k,cfg);
      if (state!=st )
	changeState(st,c,k,cfg);
    }
}
