/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include "prestataire.h"
#include <iostream>
#include "persistPrest.h"
#include "messageTM4B.h"
#include "messageLESMS.h"

/* Constructeurs */
Prestataire::Prestataire()
{
	this->hote = "";
	this->scriptEnvoi = "";
	this->persPrest = new PersistPrest();
}
	

/* Gettters et Setters */
void Prestataire::setHote(string url) {
	this->hote = url;
}
string Prestataire::getHote(void) {
	return hote;
}

void Prestataire::setScript(string script) {
	this->scriptEnvoi = script;
}

string Prestataire::getScript(void) {
	return scriptEnvoi;
}

string Prestataire::getLogin(void) {
	return login;
}
void Prestataire::setLogin(string login) {
	this->login = login;
}
	
string Prestataire::getPass(void) {
	return pass;
}
void Prestataire::setPass(string pass) {
	this->pass = pass;
}
	
string Prestataire::getNom(void) {
	return nom;
}
void Prestataire::setNom(string nom) {
	this->nom = nom;
}

/*Recupere les info dans la base de données*/
short Prestataire::recupererInfo(void) {
short err=0;
err=persPrest->read();
if (err ==0)
	{
	if (persPrest->getHote().size()!=0) setHote(persPrest->getHote()); else err=1;
	if(persPrest->getScript().size() !=0) setScript(persPrest->getScript()); else err=1;
	if (persPrest->getNom().size() !=0) setNom(persPrest->getNom()); else err=1;
	if (persPrest->getLogin().size() !=0) setLogin(persPrest->getLogin()); else err=1;
	if (persPrest->getPass().size() !=0) setPass(persPrest->getPass()); else err=1;	
	}
return err;	
}

/*Envoi un SMS selon le prestataire selectionne*/
void Prestataire::sendSMS(string message) {
	
	if (getNom() == "tm4b")
	{
		MessageTM4B mess = MessageTM4B(this,message);
		mess.construireRequeteHTTPenvoi();
		mess.envoyer();
	}
	else if (getNom() == "leSMS")
	{
		MessageLESMS mess = MessageLESMS(this,message);
		mess.construireRequeteHTTPenvoi();
		mess.envoyer();
	}
	else {
		cout<<"operateur inconnu"<<endl;
		exit(-1);
	}
	
	
}
	
Prestataire::~Prestataire() {
	delete(persPrest);
}
