#include "rah.hpp"

void Rah::init()
{
  state=0;
  state_sauv=0;
  stop=false;
}

short Rah::get_State(string s,connexion  &c)
{
  time_t t;
  temps tY;
  bool button,b=false;
  param p;
  short r=0;  
  
c.get_parameter("rah",p,0);
  tY.set_time(p.get_end_timer());
  button=p.get_button();
  time(&t);
  if ( difftime(t,timer) > (tY.get_hour()*3600+tY.get_min()*60))
       b=true; 
  
  
  // the different possible cases from the button and the timer
  if(b==true && button==true) {r=1;}
  if(b==true && button==false) r=0;
  if(b==false) r=0;
  return r;
}

bool Rah::getStop()
{
   return stop;
}

void Rah::setStop( bool stop)
{
  this->stop=stop;
}

void Rah::stopper (connexion &c,K8055 &k,config &cfg)
{
//stop the pump and set the timer2 to the current time
  k.change_state(c, cfg.OUTRAH,state,"rah");
  stop=true;
  time(&timer2);
}
  

void Rah::forceState(short forcedState,connexion &c,K8055 &k,config &cfg)
{
  if (forcedState!=state)
    {
      state_sauv=state;
      state=forcedState;
      k.change_state(c, cfg.OUTRAH,state,"rah forced");
    }
}

bool Rah::enable_rahpump(connexion  &c)
{
  time_t t;
  temps tX;
  bool b=true;
  param p;
  
//get rah's parameters
  c.get_parameter("rah",p,0);
  tX.set_time(p.get_init_timer());
  time(&t);
//if rah pump is started more than X min  
  if ( difftime(t,timer2) > (tX.get_min()*60) )
    b=false; 
  
  return b;
}



void Rah::changing(short st,connexion &c,K8055 &k,config &cfg)
{
//if the state is forced
 if(cfg.forced_rah!=0) 
         forceState(cfg.forced_rah-1,c,k,cfg);
  else {
//set the state to the previous state      
      if (state!=state_sauv)
      {
      	state=state_sauv;
	k.change_state(c, cfg.OUTRAH,state,"rah");
      }
      if (state==0)
		state=st,state_sauv=state;
	      
//stop the rah pump time ends      
      if (state==1 && stop==false)
	stopper (c,k,cfg);
            
      if (stop==true)
	{
	
//if the rah pump is started from X min
	  if (enable_rahpump(c)==false)
	    {
//stop the rah pump	      
	      state=0;
	      state_sauv=state;
	      k.change_state(c, cfg.OUTRAH,state,"rah");
	      stop=false;
	      time(&timer);
	    }
	}
    }
}
