/*
  Name : rah.hpp
  Copyright : MARTY & FOK
  Authors : MARTY Sbastien & FOK Pierre
  Description: file which contents functions to use a rah pump
*/

#ifndef _RAH_HPP_
#define _RAH_HPP_

#include "param.h"
#include "util.h"
#include "other.hpp"
#include "objet.hpp"

class Rah:public Objet
{
private:
  bool stop;// used for stopping the rah pump
  
   
  void stopper (connexion &,K8055 &,config &);//stop the rah pump
  void forceState(short,connexion &,K8055 &,config &);//force the state
  bool enable_rahpump(connexion  &);// enabling the rah pump X min

public:
  
  time_t timer;//first timer
  time_t timer2;//second timer

  Rah(){}
  void init();


  short get_State(string,connexion&);//return the current state of the rah in database : hour X hour Y : enabling rah pump X min every Y min depends of a param obj
  bool getStop();
  
  void setStop(bool);
  
  
  void changing(short st,connexion &,K8055 &k,config &);//define the state witch the rah pump had to be
  

};
#endif
