#include "temperature.hpp"

void Temperature::init()
{
  state=0;
  state_sauv=0;
  sup30=false;
  inf24=false;
}


bool Temperature::getsup30()
{
  return sup30;
}

bool Temperature::getinf24()
{
  return inf24;
}

void Temperature::setSup30 (bool sup30)
{
  this->sup30=sup30;
}

void Temperature::setInf24 (bool inf24)
{
  this->inf24=inf24;
}

void Temperature::forceState(short forcedState,connexion &c,K8055 &k,config &cfg)
{
  if (state!=forcedState)
    {
      state_sauv=state;
      state=forcedState;
      k.change_state(c, cfg.OUTTEMP,state,"chauffage forced");
    }
}

void Temperature::stopper (connexion&c,K8055&k,config&cfg)
{
  state=0;
  state_sauv=state;
  k.change_state(c, cfg.OUTTEMP,state,"chauffage");
}

void Temperature::start (connexion&c,K8055&k,config&cfg)
{
  state=1;
  state_sauv=state;
  k.change_state(c, cfg.OUTTEMP,state,"chauffage");
}


double Temperature::give(double t[20])
{
  int i,j,n,max;
  double v,r=0;
  
  max=0;
  for(i=0;i<20;i++)
    {
      v=t[i];n=0;
      for(j=0;j<20;j++)
	{if (t[j]==v) n++;}
      if (n>=max) {max=n;r=v;}
    }
  return r;
}	


void Temperature::tempState(double temperature,connexion &c,K8055&k,config &cfg)
{
//if the temp is higher than 29C for the first time  
  if (temperature > 29.0 && sup30==false)
    {
      send_mail("temperature > 29 !!!!!",c);
      sup30=true;
    }
//remove the flag of sup30
if (temperature <= 28.0 && sup30==true)
	sup30=false;
	
  
//if the temp is lower than 23C for the first time  
  if (temperature < 22.0 && state==1 && inf24==false)
    {
      send_mail("temperature < 22 !!! pb with chauffage",c);
      inf24=true;
    }
//remove the flag of inf24  
  if (temperature >= 22) inf24=false;
//if the heating's state is forced  
  if(cfg.forced_temp!=0)
    forceState(cfg.forced_temp-1,c,k,cfg);
  
  else
    {
//set the state to the previous state    
      if (state!=state_sauv)
      {
      	state=state_sauv;
  	k.change_state(c, cfg.OUTTEMP,state,"chauffage");
     }
//if the temp is higher than 28C and the heating is running        
      if (temperature > 27 && state==1) 
	stopper (c,k,cfg);
//if the temp is lower than 26C and the heating is stopped        
      if (temperature < 25.0 && state==0) 
	start(c,k,cfg);
    }
  
}
